import java.net.*;
import java.io.*;

public class SmtpURLConnection extends URLConnection 
{
    private sun.net.smtp.SmtpClient smtpClient;
    protected String to;
    protected String from;
    protected String smtpServer;

    public SmtpURLConnection(URL u, String to)
    {
        super(u);
        this.to = to;
        smtpClient = null;
    }

    public void setFrom(String from)
    {
        this.from = from;
    }

    public void setTo(String to)
    {
        this.to = to;
    }

    public void setSmtpServer(String smtpServer)
    {
        this.smtpServer = smtpServer;
    }

    public void sendIt() throws IOException
    {
        if (connected)
        {
            smtpClient.closeServer();
            connected = false;
        }
        else
            throw new IOException("nothing to send.");
    }

    public void closeServer() throws IOException
    {
        if (connected)
            smtpClient.closeServer();
    }

    protected void finalize()
    {
        try
        {
            closeServer();
        }
        catch (IOException e) {}
    }

    public void connect() throws IOException 
    {
        if (!connected) 
        {
            smtpClient = null;
            try 
            {
                smtpClient = new sun.net.smtp.SmtpClient(smtpServer);
            } 
            catch (Throwable e) 
            {
                if (smtpClient != null)
                    smtpClient.closeServer();
                if (e instanceof SecurityException) 
                {
                    throw (SecurityException)e;
                }
                throw (e instanceof IOException ? (IOException) e 
                        : new IOException(e.toString()));
            }
            if (smtpClient == null)
                throw new IOException("Couldn't connect to " + smtpServer);

            connected = true;
            smtpClient.from(from);
            smtpClient.to(to + "@" + url.getHost());
        }
    }

    public OutputStream getOutputStream() throws IOException
    {
        if (!connected)
            connect();
        return smtpClient.startMessage();
    }
}
