import java.net.*;
import java.io.*;

public class SmtpURLStreamHandler extends URLStreamHandler 
{
    String to;

    protected URLConnection openConnection(URL u) 
    {
        return new SmtpURLConnection(u, to);
    }

    protected void parseURL(URL u, String spec, int start, int limit)
    {
        String protocol = u.getProtocol();
        String host = u.getHost();

        int atSign = spec.indexOf('@', start);

        if (atSign == -1)
            to = "";
        else
        {
            to = spec.substring(start, atSign - 1);
            host = spec.substring(atSign + 1, limit);
        }

        setURL(u, protocol, host, 25, "", "");
    }
}
